package ProxyBwapi.Races

import ProxyBwapi.Techs.Techs
import ProxyBwapi.UnitClasses.UnitClasses
import ProxyBwapi.Upgrades.Upgrades
import bwapi.{TechType, UnitType, UpgradeType}

object Terran {
  lazy val SCV                  = UnitClasses.get(UnitType.Terran_SCV)
  lazy val Marine               = UnitClasses.get(UnitType.Terran_Marine)
  lazy val Firebat              = UnitClasses.get(UnitType.Terran_Firebat)
  lazy val Medic                = UnitClasses.get(UnitType.Terran_Medic)
  lazy val Ghost                = UnitClasses.get(UnitType.Terran_Ghost)
  lazy val Vulture              = UnitClasses.get(UnitType.Terran_Vulture)
  lazy val SpiderMine           = UnitClasses.get(UnitType.Terran_Vulture_Spider_Mine)
  lazy val Goliath              = UnitClasses.get(UnitType.Terran_Goliath)
  lazy val SiegeTankUnsieged    = UnitClasses.get(UnitType.Terran_Siege_Tank_Tank_Mode)
  lazy val SiegeTankSieged      = UnitClasses.get(UnitType.Terran_Siege_Tank_Siege_Mode)
  lazy val Wraith               = UnitClasses.get(UnitType.Terran_Wraith)
  lazy val Dropship             = UnitClasses.get(UnitType.Terran_Dropship)
  lazy val Valkyrie             = UnitClasses.get(UnitType.Terran_Valkyrie)
  lazy val ScienceVessel        = UnitClasses.get(UnitType.Terran_Science_Vessel)
  lazy val Battlecruiser        = UnitClasses.get(UnitType.Terran_Battlecruiser)
  lazy val NuclearMissile       = UnitClasses.get(UnitType.Terran_Nuclear_Missile)
  lazy val CommandCenter        = UnitClasses.get(UnitType.Terran_Command_Center)
  lazy val SupplyDepot          = UnitClasses.get(UnitType.Terran_Supply_Depot)
  lazy val Refinery             = UnitClasses.get(UnitType.Terran_Refinery)
  lazy val Barracks             = UnitClasses.get(UnitType.Terran_Barracks)
  lazy val Academy              = UnitClasses.get(UnitType.Terran_Academy)
  lazy val Bunker               = UnitClasses.get(UnitType.Terran_Bunker)
  lazy val EngineeringBay       = UnitClasses.get(UnitType.Terran_Engineering_Bay)
  lazy val MissileTurret        = UnitClasses.get(UnitType.Terran_Missile_Turret)
  lazy val Factory              = UnitClasses.get(UnitType.Terran_Factory)
  lazy val MachineShop          = UnitClasses.get(UnitType.Terran_Machine_Shop)
  lazy val Starport             = UnitClasses.get(UnitType.Terran_Starport)
  lazy val ControlTower         = UnitClasses.get(UnitType.Terran_Control_Tower)
  lazy val Armory               = UnitClasses.get(UnitType.Terran_Armory)
  lazy val ScienceFacility      = UnitClasses.get(UnitType.Terran_Science_Facility)
  lazy val CovertOps            = UnitClasses.get(UnitType.Terran_Covert_Ops)
  lazy val PhysicsLab           = UnitClasses.get(UnitType.Terran_Physics_Lab)
  lazy val Comsat               = UnitClasses.get(UnitType.Terran_Comsat_Station)
  lazy val NuclearSilo          = UnitClasses.get(UnitType.Terran_Nuclear_Silo)
  lazy val SpellScannerSweep    = UnitClasses.get(UnitType.Spell_Scanner_Sweep)
  lazy val WraithEnergy         = Upgrades.get(UpgradeType.Apollo_Reactor)
  lazy val MedicEnergy          = Upgrades.get(UpgradeType.Caduceus_Reactor)
  lazy val GoliathAirRange      = Upgrades.get(UpgradeType.Charon_Boosters)
  lazy val BattlecruiserEnergy  = Upgrades.get(UpgradeType.Colossus_Reactor)
  lazy val VultureSpeed         = Upgrades.get(UpgradeType.Ion_Thrusters)
  lazy val GhostEnergy          = Upgrades.get(UpgradeType.Moebius_Reactor)
  lazy val GhostVisionRange     = Upgrades.get(UpgradeType.Ocular_Implants)
  lazy val BioArmor             = Upgrades.get(UpgradeType.Terran_Infantry_Armor)
  lazy val BioDamage            = Upgrades.get(UpgradeType.Terran_Infantry_Weapons)
  lazy val AirArmor             = Upgrades.get(UpgradeType.Terran_Ship_Plating)
  lazy val AirDamage            = Upgrades.get(UpgradeType.Terran_Ship_Weapons)
  lazy val MechArmor            = Upgrades.get(UpgradeType.Terran_Vehicle_Plating)
  lazy val MechDamage           = Upgrades.get(UpgradeType.Terran_Vehicle_Weapons)
  lazy val ScienceVesselEnergy  = Upgrades.get(UpgradeType.Titan_Reactor)
  lazy val MarineRange          = Upgrades.get(UpgradeType.U_238_Shells)
  lazy val ScannerSweep         = Techs.get(TechType.Scanner_Sweep)
  lazy val WraithCloak          = Techs.get(TechType.Cloaking_Field)
  lazy val DefensiveMatrix      = Techs.get(TechType.Defensive_Matrix)
  lazy val EMP                  = Techs.get(TechType.EMP_Shockwave)
  lazy val Healing              = Techs.get(TechType.Healing)
  lazy val Irradiate            = Techs.get(TechType.Irradiate)
  lazy val Lockdown             = Techs.get(TechType.Lockdown)
  lazy val NuclearStrike        = Techs.get(TechType.Nuclear_Strike)
  lazy val OpticalFlare         = Techs.get(TechType.Optical_Flare)
  lazy val GhostCloak           = Techs.get(TechType.Personnel_Cloaking)
  lazy val Stim                 = Techs.get(TechType.Stim_Packs)
  lazy val Restoration          = Techs.get(TechType.Restoration)
  lazy val Scan                 = Techs.get(TechType.Scanner_Sweep)
  lazy val SpiderMinePlant      = Techs.get(TechType.Spider_Mines)
  lazy val SiegeMode            = Techs.get(TechType.Tank_Siege_Mode)
  lazy val Yamato               = Techs.get(TechType.Yamato_Gun)
}
